# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

package JobRecordManager;

BEGIN{
    push (@INC, "$ENV{HPCALE_SERVER_HOME}/server");
}

use db::PerlDB;
use strict;

sub new 
{
    my $classname  = shift;         # What class are we constructing?
    my $self   = {};                # Allocate new memory

    bless($self, $classname);       # Mark it of the right type
    return $self;
}

sub assign_job_id ($$)
{
    my $self = shift;
    my $user = shift;
    my $host = shift;

    my $perldb = new PerlDB();

    my $query = "insert into joblist (clienthost, clientuser, allocated, executed) values (\"$host\", \"$user\", \"void\", \"void\");";
    my $str = $perldb->executequery($query);

    my $jobs = undef;
    if($str eq "Query Succeed!"){
        $query = "select job_id from joblist where clientuser = \"$user\" and clienthost = \"$host\" and allocated = \"void\"";
        $jobs = $perldb->select($query);

        $perldb->db_end ();
        return $jobs->[0];
    }
    else{
        return -1;
    }
}

sub update_record
{
    my $self  = shift;
    my $jobid = shift;
    my $field = shift;
    my $value = shift;

    my $perldb = new PerlDB();

    my $query = "";
    my $str = "";

    if($field == 1){
        $query = "update joblist set allocated = \"$value\" where job_id = $jobid;";
        $str = $perldb->executequery($query);
    }
    elsif($field == 2){
        $query = "update joblist set executed = \"$value\" where job_id = $jobid;";
        $str = $perldb->executequery($query);
    }

    $perldb->db_end;

    if($str eq "Query Succeed!"){
        return 1;
    }
    else{
        return "[JobList] Updating Job Record for Job ID $jobid , failed : $str\n";
    }
}

1;

