# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

use strict; 

my $LockFile = $ARGV[0];
my $headJobDir = $ARGV[1];

open PBSNODEFILE, ">> $headJobDir/PBSNODES";
print PBSNODEFILE `cat $ENV{PBS_NODEFILE}`;
close PBSNODEFILE;

open O, ">> $headJobDir/allocation.log";

#
# wait until lock file is removed
#
my $i=0;
while ( -e "$headJobDir/$LockFile" ) {
    print O "Waiting...$i\n";
    $i++;
    `sleep 2`;
}

close O;

